#ifndef __CANCONNECTOR_H
#define __CANCONNECTOR_H

#include <stdio.h>

#include "inc/libcansocket.h"
#include "inc-gen/data_dictionary.h"

// types
typedef const char* CAN_MSG_T;
typedef unsigned long CAN_CLK_T;

// constants
extern const char* CAN_DEVICE_NAME;

// send and receive
void can_send();
void can_send_clock(CAN_CLK_T counter);
void can_receive();
CAN_CLK_T can_receive_clock();

// init, terminate, prepare
void can_init();
void can_term();

void prepare_input_CanConnector();
void finish_input_CanConnector();

void prepare_output_CanConnector();
void finish_output_CanConnector();

// noval
GEN_TYPE_boolean can_is_noval(CAN_MSG_T msg);
GEN_TYPE_boolean can_set_noval(CAN_MSG_T msg);

// readers
GEN_TYPE_boolean can_read_bool(CAN_MSG_T msg);
GEN_TYPE_double can_read_double(CAN_MSG_T msg);
GEN_TYPE_int can_read_int(CAN_MSG_T pomsgrt);

// writers
void can_write_bool(CAN_MSG_T msg, GEN_TYPE_boolean value);
void can_write_double(CAN_MSG_T msg, GEN_TYPE_double value);
void can_write_int(CAN_MSG_T msg, GEN_TYPE_int value);

#endif // __CANCONNECTOR_H
